
OUTPUT_FORMAT("elf32-h8300", "elf32-h8300", "elf32-h8300")
OUTPUT_ARCH(h8300s)
ENTRY(_start)

PHDRS
{
	text PT_LOAD FILEHDR PHDRS;
	data PT_LOAD;
}

/* VERY IMPORTANT.
 * The Prex ELF loader cannot handle more than one .text, .rodata, .data or
 * .bss section (all relocations to any such section end up referring to the
 * first one!). So we need to flatten all such sections into one.
 */

SECTIONS
{
	. = SIZEOF_HEADERS;

	.text : {
		*(.text)
		*(.text.*)
		*(.glue_7)
		*(.glue_7t)
	} : text = 0xff

	. = ALIGN(4);
	.rodata : {
		*(.rodata)
		*(.rodata.*)
	} : text

	. = ALIGN(4);
	.data : {
		*(.data)
		*(.data.*)
	} : data

	. = ALIGN(4);
	.bss .  : {
		*(.bss)
		*(.bss.*)
		*(COMMON)
	}

	/DISCARD/ : { *(.comment .note) }
}
